      SUBROUTINE GETTDC(IADDR)
*.
*...GETTDC   Simulate reading edge discriminator and TDC
*.
*. INPUT     : IADDR
*.
*. CALLS     : VZERO,XSRNDM
*. CALLED    : GUOUT
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : R.Sawada
*. VERSION   : 1.00
*. CREATED   : 15-Mar-03
*. LAST MOD  : 15-Mar-03
*.
*. Modification Log.
*. 15-Mar-03   R.Sawada       (V1.00) 1st version
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gconst.inc"
#include "xecgeo.inc"
#include "xecpmt.inc"
#include "xecsci.inc"
#include "xecint.inc"
#include "rcrep.inc"
#include "ntuple.inc"
*
      INTEGER IADDR
      REAL RN(2)
      REAL TCUT
      REAL BINSIZE
      REAL TIME(40000)
      REAL RISEBIN,DECAYBIN
      REAL DELAY(200000)
      REAL WEIGHT
      INTEGER I,J,K
      REAL FSTARV

      DATA TCUT / 30.0E-9 /
      DATA BINSIZE / 25.0E-12 /
      RISEBIN = RISETIME/BINSIZE
      DECAYBIN = DECAYTIME/BINSIZE

      FSTARV = 1.0
*

      CALL VZERO(TIME,40000)
      
      DO 200 I = 1,NPEPMT(IADDR)
         IF(ATIME(IADDR,I) .NE. 0.) THEN
            CALL XSRNDM(RN,1)
            DELAY(I)=-45.0E-9*LOG(RN(1))+ATIME(IADDR,I)
            IF(FSTARV .GE. ATIME(IADDR,I)) THEN
               FSTARV = ATIME(IADDR,I)
            END IF
         END IF
 200  CONTINUE

      DO 300 I = 1,NPEPMT(IADDR)
         IF(DELAY(I) .LE. FSTARV + TCUT) THEN
            IF(ATIME(IADDR,I) .NE. 0.) THEN
               DO 240 J = 1,RISEBIN
                  WEIGHT = PEAKVOLT/RISEBIN * j
                  K = DELAY(I)/BINSIZE + J
                  TIME(K) = TIME(K) + WEIGHT
 240           CONTINUE
               DO 260 J = 1,DECAYBIN
                  WEIGHT = PEAKVOLT/DECAYBIN * (DECAYBIN - J)
                  K = (DELAY(I)+RISETIME)/BINSIZE + J
                  TIME(K) = TIME(K) + WEIGHT
 260           CONTINUE
            END IF
         END IF
 300  CONTINUE
*     

      DO 400 I=1,40000
         IF(TIME(I) .LT. THRESHOLD) THEN
            GOTO 500
         END IF
 400  CONTINUE
 500  TDC(IADDR) = I*BINSIZE

 999  CONTINUE
      RETURN
      END


